// QA标签
function showQALabels(e){
	if($('#addQAlabels').length>0){
		$('#addQAlabels').remove();
		return;
	}

	$('#addQAlabels').remove();
	$('#memberlist').remove();

	var html = T( $('#tmpl-addQAlabels').html() , DATA );
	$('body').append( html );

	$('#addQAlabels').css({
		'left': e.clientX+5,
		'top':e.clientY+10
	});
}

// 添加卡片 点击添加的时候
function showQALabelsOnNewAdd(e,callback){
	if($('#firstAddQaLabels').length>0){
		$('#firstAddQaLabels').remove();
		return;
	}

	$('#firstAddQaLabels').remove();
	$('#memberlist').remove();

	var html = T( $('#tmpl-firstAddQaLabels').html() , DATA );
	$('body').append( html );

	$('#firstAddQaLabels').css({
		'left':$(document).scrollLeft()+e.clientX+5,
		'top':e.clientY+10
	});
	callback && callback(json);
}

//修改标签
function doSubmitSetQALabel(cardid,labelid,callback,timeto){
	$.get('./?app=api&apiact=set_qalabel&cardid='+cardid+"&labelid="+labelid+"&timeto="+ (timeto||"") ,function(text){
		DATA.lastShowCardID = cardid;
		var labelInfo = getQALabelInfo(DATA.boardid , labelid);

		if(labelInfo){
			var labelName = labelInfo.name;
			var myinfo = getUserInfo( MYID );
			var info = myinfo.profile.fullname || "我";
			var isCardQALabel = DATA.cards[ DATA.lastShowCardID ].qalabelIds;

			if(!isCardQALabel || DATA.cards[ DATA.lastShowCardID ].qalabelIds.indexOf( labelid ) == -1 ){
				info += '<font color=red>[增加]</font>';
			}else{
				info += '<font color=red>[删除]</font>';
			}
			info += '问题类型标签['+ labelName +']';
			//提交评论
			doSubmitCommonts( info,DATA.boardid,DATA.lastShowCardID );
			
			if(window.MYINFO && DATA.cards[ DATA.lastShowCardID ].userId != window.MYINFO._id ){
				//如果这个单子不是我创建的
				var ownerInfo = DATA.users[DATA.cards[ DATA.lastShowCardID ].userId];
				if(ownerInfo && ownerInfo.profile.fullname){
					var msgInfo = window.MYINFO.profile.fullname + "在任务["+ DATA.cards[ DATA.lastShowCardID  ].title+']中'+ info.replace('我','');
					// LeguWork 面板不发送消息
					if (DATA.boardid == 'XNt2hy8Q89tEfmwC7'){
						console.log(DATA.boardid);
					}else {
						sendDDMSG(ownerInfo.profile.fullname, msgInfo, location.href,ownerInfo.dduserid);
					}
				}
			}
		}
		
		var json = JSON.parse( text );
		emitEventByJSON(json);
		callback && callback(json);
	});
}

//增加或修改标签自身
function doSubmitModifyQALabel(boardid,labelid,labelname,labelcolor,callback){
	console.log(boardid,labelid,labelname,labelcolor);

	$.get('./?app=api&apiact=modify_qalabel&boardid='+boardid+"&labelid="+labelid+"&labelname="+ encodeURIComponent(labelname)+"&labelcolor="+labelcolor,function(text){
		
		var json = JSON.parse( text );
		emitEventByJSON(json);
		callback && callback(json);
	});
}

//删掉标签
function doSubmitDelQALabel(boardid,labelid,callback){
	console.log(boardid,labelid);

	$.get('./?app=api&apiact=del_qalabel&boardid='+boardid+"&labelid="+labelid+"&labelname=",function(text){

		var json = JSON.parse( text );
		emitEventByJSON(json);
		callback && callback(json);
	});
}

$(function(){
	//关闭x
	var _labelColor;
	$('body').on('click','.close_addQAlabels',function(){
		$('#addQAlabels').remove();
	});

	$('body').on('click','.close_first_addQAlabels',function(){
		$('#firstAddQaLabels').remove();
	});
	
	//标签后的编辑按钮
	$('body').on('click','.labelEdit',function(e){
		var name = $(this).parent().data('labelname');
		var labelcolor = $(this).parent().data('labelcolor');
		var id = $(this).parent().data('id');
		
		$('.add_qalabel_li2').click();
		$('.dellabelbtn').show();
		$('.addLabelName').val(name);
		$('.addLabelID').val(id);
		$('.addLabelUL .card-label-'+labelcolor).click();
		_labelColor = labelcolor;
		return false;
	});
	
	$('body').on('click','.labelSetTimer',function(e){
		var me = this;
		jeDate({
			dateCell:"#"+ $(this).attr('id'),
			format:"YYYY-MM-DD",
			isinitVal:false,
			isTime:false,
			festival:true,
			okfun : function(val){
				setLabelWithTimer(val,me);
			},
			choosefun : function(val){
				setLabelWithTimer(val,me);
			}
		});
		return false;
	});
	
	function setLabelWithTimer(val,obj){
		//alert(val);
		//var valArr = val.split('-');
		$(obj).html("");
		$(obj).parent().data('timeto',val).click();
	}
	
	//列表点击
	$('body').on('click','.qalabel_li',function(e){
		
		var id = $(this).data('id');
		var timeto = $(this).data('timeto');
		$(this).data('timeto','');
		if(!id){
			//增加标签按钮
			$('.chooseLabelUL').hide();
			$('.addLabelUL').show();
			$('.qalabelback').show();
			
			$('.addLabelName').val('');
			$('.addLabelID').val('');
			$('.dellabelbtn').hide();
			return;
		}
		
		doSubmitSetQALabel( DATA.lastShowCardID , id, function(json){
			var html = T( $('#tmpl-addQAlabels').html() , DATA );
			html = html.replace(/\t/g,'').replace(/\n/g,'').replace(/\r/g,'');
			$('#addQAlabels .card-labelid-'+ id).html( $(html).find('.card-labelid-'+ id).html() );
			$('.close_addQAlabels').click();
		},timeto);
	});

	//第一次列表点击
	$('body').on('click','.first_qalabel_li',function(e){

		var id = $(this).data('id');
		var timeto = $(this).data('timeto');
		$(this).data('timeto','');
		if(!id){
			//增加标签按钮
			$('.chooseLabelUL').hide();
			$('.addLabelUL').show();
			$('.qalabelback').show();

			$('.addLabelName').val('');
			$('.addLabelID').val('');
			$('.dellabelbtn').hide();
			return;
		}

		doSubmitSetQALabel(DATA.lastShowCardID, id, function (json) {
			var html = T($('#tmpl-firstAddQaLabels').html(), DATA);
			html = html.replace(/\t/g, '').replace(/\n/g, '').replace(/\r/g, '');
			$('#firstAddQaLabels .card-labelid-' + id).html($(html).find('.card-labelid-' + id).html());

			$('.close_first_addQAlabels').click();
			$('#firstlabelcardinfoMask').hide();

			showCard( DATA.lastShowCardID ,function () {
				$('.cardinfo_description').click();
				$('.cardinfo_description_editor').select();

			});

		}, timeto);
	});
	
	//新增or修改标签
	
	$('body').on('click','.qalabelback',function(){
		var _left = $('#addQAlabels').css('left');
		var _top = $('#addQAlabels').css('top');
		
		$('.close_addQAlabels').click();
		$('.cardinfo_addQAlabels').click();
		
		$('#addQAlabels').css({left:_left,top:_top});
	});
	
	$('body').on('click','.add_qalabel_li',function(){
		$('.add_qalabel_li').html('&nbsp;');
		$(this).html('<i class="fa fa-check"></i>');
		_labelColor = $(this).data('labelcolor');
	});

	// 添加标签
	$('body').on('click','.addQAlabelbtn',function(){
		var _name = $('.addLabelName').val();
		var _id = $('.addLabelID').val();
		if(_name.length==0)return;
		checkPermission('QAlabels',function (isok) {
			if(isok) {
				doSubmitModifyQALabel(DATA.boardid,_id,_name,_labelColor,function(){
					$('.qalabelback').click();
				});
			}else{
				alert('你没有权限修改')
			}
		});
		

	});

	// 删除标签
	$('body').on('click','.delQAlabelbtn',function(){
		// var _name = $('.addLabelName').val();
		var _id = $('.addLabelID').val();

		// if(_name.length==0)return;
		checkPermission('QAlabels',function (isok) {
			if(isok) {
				doSubmitDelQALabel(DATA.boardid,_id,function(){
					$('.qalabelback').click();
				});
			}else {
				alert('你没有权限删除');
			}
		});


	});
});
